/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.reseller.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for subscription seats.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Enterprise Apps Reseller API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Seats extends GenericJson {

  /**
   * Identifies the resource as a subscription change plan request.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Maximum number of seats that can be purchased. This needs to be provided only for a non-
   * commitment plan. For a commitment plan it is decided by the contract.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer maximumNumberOfSeats;

  /**
   * Number of seats to purchase. This is applicable only for a commitment plan.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer numberOfSeats;

  /**
   * Identifies the resource as a subscription change plan request.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Identifies the resource as a subscription change plan request.
   * The value set may be {@code null}.
   */
  public Seats setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Maximum number of seats that can be purchased. This needs to be provided only for a non-
   * commitment plan. For a commitment plan it is decided by the contract.
   * The value returned may be {@code null}.
   */
  public Integer getMaximumNumberOfSeats() {
    return maximumNumberOfSeats;
  }

  /**
   * Maximum number of seats that can be purchased. This needs to be provided only for a non-
   * commitment plan. For a commitment plan it is decided by the contract.
   * The value set may be {@code null}.
   */
  public Seats setMaximumNumberOfSeats(Integer maximumNumberOfSeats) {
    this.maximumNumberOfSeats = maximumNumberOfSeats;
    return this;
  }

  /**
   * Number of seats to purchase. This is applicable only for a commitment plan.
   * The value returned may be {@code null}.
   */
  public Integer getNumberOfSeats() {
    return numberOfSeats;
  }

  /**
   * Number of seats to purchase. This is applicable only for a commitment plan.
   * The value set may be {@code null}.
   */
  public Seats setNumberOfSeats(Integer numberOfSeats) {
    this.numberOfSeats = numberOfSeats;
    return this;
  }

}
